unit c_main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  ExtCtrls, ToolWin, JvComponent, JvSearchFiles,
  XPMan, ExtDlgs, JvExControls, JvXPCore, JvXPButtons, StdCtrls, JPEG, PNGImage,
  JvGIF, ImgList, GR32, GR32_Image, JvBaseDlg, JvSelectDirectory, ShlObj,
  JvXPCheckCtrls, SsBase, StDrop, StBrowsr, JustOne, JvExStdCtrls,
  JvCombobox, JvComponentBase, ShellAPI, StFileOp, cHash, Registry, AES,
  xmldom, XMLIntf, msxmldom, XMLDoc, cUnicode, TntStdCtrls, TntDialogs,
  TntMenus, TntExtDlgs, TntComCtrls, TntButtons, TntExtCtrls, c_unicode,
  Buttons, Menus, ComCtrls, Dialogs, TypInfo, TntClasses, JvSpin,
  TFlatPanelUnit, EasyFileSearch, FileSearch, ComObj, ActiveX, JvEdit,
  JvValidateEdit, Mask, JvExMask, JvToolEdit, JvBaseEdits, TFlatEditUnit,
  TFlatSpinEditUnit, ExifInfo;

type
  TEncodeFlags = (efUnknown, efAnsi, efUnicode, efUncodeBigEn, efUTF8);
  TMainform = class(TForm)
    Image1: TImage;
    MainMenu1: TTntMainMenu;
    Menu_Files: TTntMenuItem;
    Menu_Help: TTntMenuItem;
    JvSearchFiles1: TJvSearchFiles;
    XPManifest1: TXPManifest;
    ImageList1: TImageList;
    PageControl1: TTntPageControl;
    TabSheet_Step_1: TTntTabSheet;
    TabSheet_Step_2: TTntTabSheet;
    ListView1: TTntListView;
    Panel2: TTntPanel;
    Label2: TTntLabel;
    Panel3: TTntPanel;
    Label1: TTntLabel;
    Panel1: TTntPanel;
    Image321: TImage32;
    Label_Hint: TTntLabel;
    StDropFiles1: TStDropFiles;
    PopupMenu1: TTntPopupMenu;
    Menu_Addimages: TTntMenuItem;
    Menu_Addfolder: TTntMenuItem;
    N1: TTntMenuItem;
    Menu_RemoveImages: TTntMenuItem;
    Menu_Removeall: TTntMenuItem;
    Menu_About: TTntMenuItem;
    N2: TTntMenuItem;
    Menu_WebsiteofPhototo: TTntMenuItem;
    Menu_Helpdoc: TTntMenuItem;
    CheckBox_Preview: TTntCheckBox;
    StFileOperation1: TStFileOperation;
    TabSheet_Generate: TTntTabSheet;
    ProgressBar1: TTntProgressBar;
    Edit_Album_Title: TTntEdit;
    Label_Album_Title: TTntLabel;
    Label_Album_Comments: TTntLabel;
    Edit_Album_Comments: TTntMemo;
    ComboBox_Photo_Size: TTntComboBox;
    Label_Photo_Size: TTntLabel;
    ComboBox_Style: TTntComboBox;
    Label_Web_Album_Themes: TTntLabel;
    Edit_DestDir: TTntEdit;
    Label_Output_Folder: TTntLabel;
    Label_States: TTntLabel;
    N3: TTntMenuItem;
    Menu_Exit: TTntMenuItem;
    Edit_BacktoHome: TTntEdit;
    CheckBox_BacktoHome: TTntCheckBox;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Label_Finished: TTntLabel;
    Bevel4: TBevel;
    Btn_Select_Folder: TTntBitBtn;
    Btn_Add_Images: TTntBitBtn;
    Btn_Add_Folder: TTntBitBtn;
    Btn_Remove_Images: TTntBitBtn;
    Btn_Remove_All: TTntBitBtn;
    Btn_Modify_Selected: TTntBitBtn;
    Btn_Up: TTntBitBtn;
    Btn_Down: TTntBitBtn;
    Btn_View_Album: TTntBitBtn;
    Btn_Open_folder: TTntBitBtn;
    Btn_Next: TTntBitBtn;
    Btn_Back: TTntBitBtn;
    Bevel5: TBevel;
    N4: TTntMenuItem;
    Menu_Checkforanewversion: TTntMenuItem;
    Menu_Newproject: TTntMenuItem;
    Menu_Loadproject: TTntMenuItem;
    Menu_Saveproject: TTntMenuItem;
    N5: TTntMenuItem;
    Menu_SaveAlbumas: TTntMenuItem;
    SaveDialog1: TTntSaveDialog;
    XMLDocument1: TXMLDocument;
    OpenDialog1: TTntOpenDialog;
    Menu_InterfaceLanguage: TTntMenuItem;
    JvSearchFiles2: TJvSearchFiles;
    TntButton1: TTntButton;
    Menu_Get_Update_Language: TTntMenuItem;
    N6: TTntMenuItem;
    OpenPictureDialog1: TOpenPictureDialog;
    FlatPanel1: TFlatPanel;
    Label_Howto_upload: TTntLabel;
    EasyFileSearch1: TEasyFileSearch;
    TntLabel1: TTntLabel;
    Btn_Generate: TTntBitBtn;
    Image_preview: TTntImage;
    TntLabel2: TTntLabel;
    bvl1: TBevel;
    ComboBox_Style2: TTntComboBox;
    bvl3: TBevel;
    Edit_Columns: TTntEdit;
    Edit_Row: TTntEdit;
    Label_Thumbnail_layout: TTntLabel;
    Label_Columns: TTntLabel;
    Label_Row: TTntLabel;
    ExifInfo1: TExifInfo;
    Image2: TImage;
    TntLabel3: TTntLabel;
    StFileOperation2: TStFileOperation;
    Label3: TLabel;
    procedure Btn_Add_FolderClick(Sender: TObject);
    procedure ListView1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListView1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure StDropFiles1DropFiles(Sender: TObject; Point: TPoint);
    procedure JvSearchFiles1FindFile(Sender: TObject; const AName: String);
    procedure Btn_NextClick(Sender: TObject);
    procedure Btn_BackClick(Sender: TObject);
    procedure CheckBox_PreviewClick(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure Btn_Open_folderClick(Sender: TObject);
    procedure Menu_ExitClick(Sender: TObject);
    procedure CheckBox_BacktoHomeClick(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure Btn_GenerateClick(Sender: TObject);
    procedure Btn_Select_FolderClick(Sender: TObject);
    procedure Btn_Add_ImagesClick(Sender: TObject);
    procedure Btn_Remove_ImagesClick(Sender: TObject);
    procedure Btn_Remove_AllClick(Sender: TObject);
    procedure Btn_DownClick(Sender: TObject);
    procedure Btn_View_AlbumClick(Sender: TObject);
    procedure Btn_Modify_SelectedClick(Sender: TObject);
    procedure Menu_AboutClick(Sender: TObject);
    procedure Menu_WebsiteofPhototoClick(Sender: TObject);
    procedure Menu_CheckforanewversionClick(Sender: TObject);
    procedure Menu_HelpdocClick(Sender: TObject);
    procedure Btn_UpClick(Sender: TObject);
    procedure Menu_NewprojectClick(Sender: TObject);
    procedure Menu_SaveprojectClick(Sender: TObject);
    procedure Menu_LoadprojectClick(Sender: TObject);
    procedure Menu_SaveAlbumasClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Edit_Album_CommentsChange(Sender: TObject);
    procedure Edit_Album_TitleChange(Sender: TObject);
    procedure ComboBox_Photo_SizeChange(Sender: TObject);
    procedure ComboBox_StyleChange(Sender: TObject);
    procedure Edit_DestDirChange(Sender: TObject);
    procedure Edit_BacktoHomeChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure JvSearchFiles2FindFile(Sender: TObject; const AName: String);
    procedure FormShow(Sender: TObject);
    procedure TntButton1Click(Sender: TObject);
    procedure Menu_AddimagesClick(Sender: TObject);
    procedure Menu_AddfolderClick(Sender: TObject);
    procedure Menu_RemoveImagesClick(Sender: TObject);
    procedure Menu_RemoveallClick(Sender: TObject);
    procedure Menu_Get_Update_LanguageClick(Sender: TObject);
    procedure Label_Howto_uploadClick(Sender: TObject);
    procedure EasyFileSearch1FileFound(FileFound: TFileInformations);
    procedure ComboBox_Style2Change(Sender: TObject);
    procedure Label3Click(Sender: TObject);
    procedure Label3MouseEnter(Sender: TObject);
    procedure Label3MouseLeave(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure MenuItem_Click(Sender: TObject);
    function MyGetFileSize(cfile:string):string; //ļС fang.2002.12.23
    procedure COME_Add_Images(filename: string);
    procedure COME_Add_Folder(filename: string);
    procedure COME_Deal_ParaStr;
    procedure COME_Deal_PreviewThumb(filename: string);
    procedure COME_Modify_Resize(src_bitmap32: TBitmap32;newWidth,newHeight:Integer; var dst_bitmap32: TBitmap32);
    procedure COME_Modify_Rotate(src_bitmap32: TBitmap32; newDegrees : integer; var dst_bitmap32: TBitmap32);
    procedure COME_Get_Listview1_ID;
    procedure COME_Set_Listview1_Index(New_Index: integer);
    procedure COME_Make_Thumb(OutPutPath : string;
                              PicBox_Sidesize : integer = 128;
                              CompressionQuality : integer = 85);
    procedure COME_Make_View_Photo(OutPutPath : string; CompressionQuality : integer = 85);
    procedure COME_Deal_ReplaceStr(TempletFile: string; outputpath: string; OutPutFileName: string; itemindex: Integer; curpage : Integer=0; custom_text: string='');
    procedure COME_WEBINFO(INFO : integer);
    procedure COME_Project_New;
    procedure COME_Project_Load(loadfilename : string = '');
    procedure COME_Project_Save;
    procedure COME_Project_Save_as(filename : string = '');
    procedure COME_Language(Language_File : string);
    procedure COME_Language_Write_XML(Language_File : string);
    procedure COME_Languages_To_Menu(xml_filename: string);
    function COME_Languages_Get_Str(StrList, StrList_Back : TTntStringList; index : Integer; Check : Boolean = False):WideString;
    procedure COME_Write_Config_XML(XML_File : string; Name : WideString; Value : WideString);
    function COME_Read_Config_XML(XML_File : string; Name : WideString): WideString;
    procedure COME_Read_Skin_XML(XML_File : string);
    procedure COME_Deal_Rotate_Flip(Image32 : TBitmap32; rotate_int, flip_v_int, flip_h_int : Integer);
    procedure COME_Save_photolist(outputpath: string);
    procedure ReceiveParam;
  end;

const
  AES_Key = '5lzmH3dmMdPGvGbum73mq1odWFNgI7m3';
  iWebAlbum_Version = '2.02';

  // 2.01 fixed ' mark in filelist will make output crash.
  //  2.02 fixed guid problem, delete { - } mark from guid string.

var
  Mainform : TMainform;
  MainBitmap32 : TBitmap32;
  breakloopbool : Boolean;
  APP_PATH, APP_LANGUAGE_PATH, APP_CONFIG_FILENAME, APP_PHOTO_PATH, APP_RES_PATH : string;
  Pages: Integer;
  Save_Changed : Boolean;
  Saved_Filename : string;
  G_for_Language : Boolean;
  G_Language_Filename: string;
  G_Language, G_Language_Translator : WideString;
  G_Check : boolean;
  temp_preview_filename : string;

  Language_Strs, Language_Strs_Backup : TTntStringList;
  Language_HTML_Strs, Language_HTML_Strs_Backup : TTntStringList;

  SkinPath : string;
  StylePath : string;

  Style_Config_outputtype,
  Style_Config_thumbnailsize,
  Style_Config_folder,
  Style_Config_preview,
  Style_Config_default_columns,
  Style_Config_default_columns_enabled,
  Style_Config_default_rows,
  Style_Config_default_rows_enabled,
  Style_Config_viewpage_bool,
  Style_Config_thumbnails_per_page,
  Style_Config_indexpage_template_file,
  Style_Config_viewpage_template_file: string;

implementation

uses c_modify, c_about;

{$R *.dfm}

type
  TUTF8Falg = packed record
    EF, BB, BF: Byte;
  end;

const
  Encode: TUTF8Falg = (EF: $EF; BB: $BB; BF: $BF);

function ChangeGuid(str : string): string;
var
  tmpstr : string;
begin
  tmpstr := str;
  if tmpstr[1] = '{' then Delete(tmpstr,1,1);
  if tmpstr[Length(tmpstr)] = '}' then Delete(tmpstr, Length(tmpstr), 1);
  while Pos('-',tmpstr) > 0 do
    Delete(tmpstr, pos('-',tmpstr), 1);
  Result := LowerCase(tmpstr);
end;

function ChkFolder(str : string): string;
begin
  Result := str;
  if str[length(str)] <> '\' then Result := Result + '\';
end;

function GetMyDocumentDirectory : string;
var
  reg : TRegistry;
begin
  try
    reg := TRegistry.Create;
    reg.RootKey := HKEY_CURRENT_USER;
    reg.OpenKey('Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders',false);
    result := reg.ReadString('Personal');
    reg.CloseKey;
    reg.free;
  except
    result := 'C:'
  end;
end;

function CopyDirectoryTree(AHandle:THandle;AFromDir,AToDir:String):boolean;
Var SHFileOpStruct:TSHFileOpStruct;
Begin
  with SHFileOpStruct Do
  Begin
    Wnd := AHandle;
    wFunc := FO_COPY;
    pFrom := PChar(AFromDir);
    pTo := PChar(AToDir);
    fFlags := FOF_NOCONFIRMATION or FOF_NOCONFIRMMKDIR or FOF_FILESONLY	;
    fAnyOperationsAborted := True;
    hNameMappings := nil;
    lpszProgressTitle := nil;
  End;
  If ShFileOperation(SHFileOpStruct)= 0 Then
    Result:= True
  Else
    Result:= false;
end;

function  TMainform.MyGetFileSize(cfile:string):string; //ļС fang.2002.12.23
var
  sr: TSearchRec;
  tmpSize: integer;
begin
  if findfirst(cfile,faAnyFile,sr)=0 then
    tmpSize := sr.Size
  else
    tmpSize := 0;

  Result := FormatFloat('#,###" KB"', (tmpSize+1023) div 1024);
  findclose(sr);
end;

function WhichImageFile(const FileName: WideString): Integer;
var
  Ext : string;
begin
  Ext := UpperCase(ExtractFileExt(FileName));

  Result := -1; // return -1 mean: not image type.

  if (Ext='.JPG') or (Ext='.JPE') or (Ext='.JPEG') then Result := 0;
  if (Ext='.PNG') then Result := 1;
  if (Ext='.BMP') then Result := 2;
  if (Ext='.GIF' ) then Result := 3;
end;

//========================================================================

procedure TMainform.COME_Add_Images(filename: string);
var
tmp : TTntListItem;
i : integer;
id : TGUID;
tmpstr : string;
begin

  for i := 0 to ListView1.Items.Count -1 do
   if ListView1.Items[i].SubItems[3] = filename then Exit;

  if WhichImageFile(filename) = -1 then Exit;

  Application.ProcessMessages;

  try
  ExifInfo1.ImageFileName := filename;
    if ExifInfo1.IsExif(filename) then
    begin
      if ExifInfo1.TagExists(Exif_DateTimeOriginal, eiExif) then
        tmpstr := ExifInfo1.DateTimeOriginalText
      else
        tmpstr := '';
    end;
  except
  end;

  tmp := ListView1.Items.Add;
  tmp.Caption := '';
  tmp.ImageIndex := WhichImageFile(filename);
  tmp.SubItems.Add(copy(trim(extractfilename(filename)),1,pos('.',extractfilename(filename))-1));   //get image filename without ".jpg"
  tmp.SubItems.Add('');
  tmp.SubItems.Add(MyGetFileSize(filename));
  tmp.SubItems.Add(filename);
  tmp.SubItems.Add(tmpstr);

  if CoCreateGuid (Id) = s_OK then
    tmp.SubItems.Add( ChangeGuid(GUIDToString(id)))
  else
    ShowMessage('GUID Error, please contact the author, thanks.');

  tmp.SubItems.Add('');
  tmp.SubItems.Add('');
  tmp.SubItems.Add('');    

  Label1.Hint := IntToStr(ListView1.Items.Count);
  Label1.Caption := Language_HTML_Strs[2]+ ': ' + Label1.Hint;

  Save_Changed := true;
end;

procedure TMainform.COME_Add_Folder(filename: string);
begin
  JvSearchFiles1.RootDirectory := filename;
  JvSearchFiles1.Search;
end;

procedure TMainform.JvSearchFiles1FindFile(Sender: TObject;
  const AName: String);
begin
  Application.ProcessMessages;
  COME_Add_Images(AName);
end;

procedure TMainform.COME_Deal_PreviewThumb(filename: string);
var
  U_Width, U_Height : integer;
  U_Biger: integer;
  rotate_int, flip_v_int, flip_h_int : Integer;  
begin
//ShowMessage('xx');

  if filename = temp_preview_filename then Exit;

  try
    if CheckBox_Preview.Checked then
    begin
      Image321.Bitmap.LoadFromFile(filename);
      U_Width := Image321.Bitmap.Width;
      U_Height := Image321.Bitmap.Height;

      if U_Width >= U_Height then U_Biger := U_Width else U_Biger := U_Height;

      if (U_Width > 175) or (U_Height > 175) then
      begin
        Image321.ScaleMode := smScale;
        Image321.Scale := 175 / U_Biger;
      end
      else
        Image321.ScaleMode := smNormal;

      Image321.Bitmap.StretchFilter := sfLanczos;

      rotate_int := StrToIntDef(ListView1.Selected.SubItems[6], 0);
      flip_v_int := StrToIntDef(ListView1.Selected.SubItems[7], 0);
      flip_h_int := StrToIntDef(ListView1.Selected.SubItems[8], 0);

      COME_Deal_Rotate_Flip(Image321.Bitmap, rotate_int, flip_v_int, flip_h_int);

      Label2.Caption := IntToStr(U_Width)+'x'+IntToStr(U_Height)+', '+ MyGetFileSize(filename);
    end;
  except
  end;

  temp_preview_filename := filename;
end;

procedure TMainform.Btn_Add_FolderClick(Sender: TObject);
var
  Info:TBrowseInfoW;
  Dir:array[0..260] of char;
  ItemId:PItemIDList;
  PathStr : string;
begin
  with Info do
  begin
    hwndOwner:=Self.Handle;
    pidlRoot:=nil;
    pszDisplayName:=nil;
    lpszTitle:= PWideChar(COME_Languages_Get_Str(Language_Strs, Language_Strs_Backup, 17));
    ulFlags:=0 or $0040;
    lpfn:=nil;
    lParam:=0;
    iImage:=0;
  end;
  ItemId:=SHBrowseForFolderW(Info);
  SHGetPathFromIDList(ItemId,@Dir);
  PathStr:=string(Dir);

  if PathStr<>'' then
  begin
    COME_Add_Folder(PathStr);
    COME_Get_Listview1_ID;
  end;

end;

// Deal ParaStr. 3 ways. <<
//===========================================================================

procedure TMainform.COME_Deal_ParaStr;
var
i : integer;
begin
  for i := 1 to ParamCount do
  begin
    if UpperCase(ExtractFileExt(ParamStr(i))) = '.IWA' then COME_Project_Load(ParamStr(i))
    else
    begin
      if UpperCase(ParamStr(i)) = '/LANGUAGEXML' then TntButton1.Show
      else
      begin
        if DirectoryExists(ParamStr(i)) then
          COME_Add_Folder(ParamStr(i))
        else
          COME_Add_Images(ParamStr(i));

          COME_Get_Listview1_ID;
      end;
    end;
  end;
end;

procedure TMainForm.ReceiveParam;
var
  i:integer;
begin
  for i := 0 to JustOneApplication.Params.Count-1 do
  begin
    if UpperCase(ExtractFileExt(JustOneApplication.Params.Strings[i])) = '.IWA' then COME_Project_Load(JustOneApplication.Params.Strings[i])
    else
    begin
    if DirectoryExists(JustOneApplication.Params.Strings[i]) then
      COME_Add_Folder(JustOneApplication.Params.Strings[i])
    else
      COME_Add_Images(JustOneApplication.Params.Strings[i]);
    end;
  end;
end;

procedure TMainform.StDropFiles1DropFiles(Sender: TObject; Point: TPoint);
var
i : integer;
begin
  for i := 0 to StDropFiles1.Files.count -1 do
  begin
    if DirectoryExists(StDropFiles1.Files[i]) then
      COME_Add_Folder(StDropFiles1.Files[i])
    else
      COME_Add_Images(StDropFiles1.Files[i]);
  end;

  COME_Get_Listview1_ID;
end;

//===========================================================================
// Deal ParaStr. 3 ways.>>

procedure SetFileAssociate(MyExt,MyFileType,FileTypeDescription,Exefile:string);
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CLASSES_ROOT;

    Reg.OpenKey(MyExt, True);
    Reg.WriteString('', MyFileType);
    Reg.CloseKey;

    Reg.OpenKey(MyFileType, True);
    Reg.WriteString('', FileTypeDescription);
    Reg.CloseKey;

    Reg.OpenKey(MyFileType + '\DefaultIcon', True);
    Reg.WriteString('', Exefile + ',0');
    Reg.CloseKey;

    Reg.OpenKey(MyFileType + '\Shell\Open', True);
    Reg.WriteString('', '&Open');
    Reg.CloseKey;

    Reg.OpenKey(MyFileType + '\Shell\Open\Command', True);
    Reg.WriteString('', '"' + Exefile + '" "%1"');
    Reg.CloseKey;

    SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_IDLIST, nil, nil);
  finally
    Reg.Free;
  end;
end;

procedure TMainform.ListView1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if ListView1.SelCount > 0 then
    COME_Deal_PreviewThumb(ListView1.Selected.SubItems[3]);
end;

procedure TMainform.ListView1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin      //46=delete key
if ListView1.SelCount > 0 then
  begin
    if Key = 46 then Btn_Remove_Images.Click else
      COME_Deal_PreviewThumb(ListView1.Selected.SubItems[3]);
  end;
end;

procedure TMainform.ListView1SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  Btn_Remove_Images.Enabled := Selected;
  Btn_Up.Enabled := Selected;
  Btn_Down.Enabled := Selected;
  Btn_Modify_Selected.Enabled := Selected;
  Menu_RemoveImages.Enabled := Selected;

  if Selected then
  begin
    if ListView1.Selected.Index = 0 then
    begin
      Btn_Up.Enabled := False;
    end;

    if ListView1.Selected.Index = ListView1.Items.Count -1 then
    begin
      Btn_Down.Enabled := False;
    end;

//    COME_Deal_PreviewThumb(ListView1.Selected.SubItems[3]);
  end;
end;

procedure TMainform.Btn_NextClick(Sender: TObject);
begin
  PageControl1.SelectNextPage(True);
end;

procedure TMainform.Btn_BackClick(Sender: TObject);
begin
  PageControl1.SelectNextPage(False);
end;

procedure TMainform.CheckBox_PreviewClick(Sender: TObject);
begin
  if not(CheckBox_Preview.Checked) then
  begin
    Image321.Bitmap.Delete;
    Label2.Caption := '';
  end
  else
  if ListView1.SelCount > 0 then COME_Deal_PreviewThumb(ListView1.Selected.Caption)
  else
    if ListView1.Items.Count > 0 then COME_Deal_PreviewThumb(ListView1.Items[0].Caption);
end;

procedure TMainform.COME_Modify_Resize(src_bitmap32: TBitmap32; newWidth,
  newHeight: Integer; var dst_bitmap32: TBitmap32);
begin
  dst_bitmap32.SetSize(newWidth, newHeight);
  dst_bitmap32.Draw( Rect(0,0,newWidth,newHeight),
                     Rect(0,0,src_bitmap32.Width,src_bitmap32.Height),
                     src_bitmap32 );
end;

procedure TMainform.COME_Modify_Rotate(src_bitmap32: TBitmap32;
  newDegrees : Integer; var dst_bitmap32: TBitmap32);
begin
  if newDegrees = 90 then src_bitmap32.Rotate90(dst_bitmap32)
  else if newDegrees = 180 then src_bitmap32.Rotate180(dst_bitmap32)
    else if newDegrees = 270 then src_bitmap32.Rotate270(dst_bitmap32)
      else
      begin

      end;
end;

procedure TMainform.COME_Get_Listview1_ID;
var
  i : integer;
begin
  ListView1.Items.BeginUpdate;
  for i := 0 to (ListView1.Items.Count-1) do
  begin
    ListView1.Items[i].Caption := IntToStr(i+1);
  end;
  ListView1.Items.EndUpdate;
end;

procedure TMainform.COME_Set_Listview1_Index(New_Index: integer);
var
  tltemp:TTntListItem;
begin
  tltemp := TTntListItem.Create(ListView1.Items);
  tltemp.Assign(ListView1.Selected);
  ListView1.Selected.Delete;
  ListView1.Items.Insert(New_Index).Assign(tltemp);
  tltemp.Free;

  Save_Changed := true;
  COME_Get_Listview1_ID;

  ListView1.SetFocus;
  ListView1.ItemIndex := New_Index ;
  ListView1.Selected.MakeVisible(True);
end;

procedure TMainform.ListView1DblClick(Sender: TObject);
begin
  if ListView1.SelCount > 0 then Btn_Modify_Selected.OnClick(Self);
end;

function UnicodeEncode(Str:string;CodePage:integer):WideString;
var
  Len:integer;
begin
  Len:=Length(Str)+1;
  SetLength(Result,Len);
  Len:=MultiByteToWideChar(CodePage,0,PChar(Str),-1,PWideChar(Result),Len);
  SetLength(Result,Len-1); //end is #0
end;

function UnicodeDecode(Str:WideString;CodePage:integer):string;
var
  Len:integer;
begin
  Len:=Length(Str)*2+1;  //one for #0
  SetLength(Result,Len);
  Len:=WideCharToMultiByte(CodePage,0,PWideChar(Str),-1,PChar(Result),Len,nil,nil);
  SetLength(Result,Len-1);
end;

procedure TMainform.COME_Deal_ReplaceStr(TempletFile: string; outputpath: string; OutPutFileName: string; itemindex: Integer; curpage : Integer=0; custom_text: string='');
var
  str1 : WideString;
  posindex, posindex2 : Integer;
  tmpstr : WideString;
  newstr1 : WideString;
  tmpstr2 : string;
  strzzz : TStringList;
  textsave : TStringList;
  GENEBY_bool : Boolean;
  i : Integer;
  mem : TStream;
begin
  textsave := TStringList.Create;
  textsave.Clear;

  strzzz := TStringList.Create;
  strzzz.LoadFromFile(TempletFile);
  str1 := ChAnsiToWide(strzzz.text);

  GENEBY_bool := False;
  posindex  := Pos('$!$[', str1);
  while posindex>0 do
  begin
    posindex2 := Pos(']$!$', str1);
    tmpstr := Copy(str1,posindex+4,posindex2-posindex-4);
    newstr1 := '[undefined terms]';
    case HashString(tmpstr) of
      3621930277 : // GENVER
      begin
        newstr1 := 'iWebAlbum '+ iWebAlbum_Version +'; http://eunq.com/';
      end;

      685660780 : // ALBUM_TITLE
        newstr1 := Trim(Edit_Album_Title.Text);
      978597726 : // ALBUM_COMMENTS
        newstr1 := Trim(Edit_Album_Comments.Text);
      3336007742 : // ALBUM_DIV
        newstr1 := custom_text;

      597477234 : // ALBUM_PAGES
      begin
        if Pages > 1 then
        begin
        newstr1 := '';

          if curpage = 1 then
            newstr1 := '<span>Previous Page</span>'
          else
            if curpage = 2 then newstr1 :=  '<span><a href="index.html">Previous Page</a></span>'
            else
              newstr1 := '<span><a href="index_'+inttostr(curpage-1)+'.html">Previous Page</a></span>';

          for i := 1 to Pages do
          begin
            if i = curpage then newstr1 := ' ' + newstr1 + '<span>'+inttostr(i)+'</span>'
            else
            begin
              if i = 1 then
                newstr1 := newstr1 + '<span><a href="index.html">1</a></span>'
              else
                newstr1 := newstr1 + ' <span><a href="index_'+inttostr(i)+'.html">'+inttostr(i)+'</a></span>';
            end;
          end;

          if curpage = Pages then
            newstr1 := newstr1 + ' <span>Next Page</span>'
          else
            newstr1 := newstr1 + ' <span><a href="index_'+inttostr(curpage+1)+'.html">Next Page</a></span>';

        end
        else
          newstr1 := '';
      end;

      3654374609 : // ALBUM_SLIDESHOW
      begin
        newstr1 := '<a href="#" onclick="return GB_showImageSet(iWebAlbumPhotos, 1, ''startslideshow'')" title="Start Slideshow">Start slideshow</a>';
      end;  

      522716604 : // BACK_TO_HOME
      if (CheckBox_BacktoHome.Checked) and (UpperCase(Edit_BacktoHome.Text) <> 'HTTP://') then
        newstr1 := '<a href="' + Edit_BacktoHome.Text + '">'+ COME_Languages_Get_Str(Language_HTML_Strs, Language_HTML_Strs_Backup, 9, True) +'</a>'
      else
        newstr1 := '';
      286332739 : // GENEBY
      begin
        newstr1 := trim(DecryptString('3600000000000000E4AE4CD27E366E004F891860CF95F24BC9E237A44A7A29F22C5C30C4713C9732F02DA26360A62E63BE6F0627FB7314B8656F10D672C18D6FC90588446B986EE6',
                  AES_Key, kb256));
                  //Generated by <a href="http://eunq.com">iWebAlbum</a>
        GENEBY_bool := True;
      end;
      else newstr1 := '[undefined terms]';
    end;

   if posindex> 0 then
   begin
    Delete(str1,posindex,8+ Length(tmpstr));
    Insert(newstr1, str1, posindex);
   end;

   posindex  := Pos('$!$[', str1);
  end;

  if GENEBY_bool then
  begin    
    mem := TMemoryStream.Create;
    UnicodeToUTF8Stream(str1, mem);
    TMemoryStream(mem).SaveToFile(outputpath + OutPutFileName);
    mem.Size := 0;
    mem.Free;
  end
  else
  begin
    Application.MessageBox('No Generator information!' + #13#10 +
    'Please add $!$[GENEBY]$!$ to the HTML templet.  ' + #13#10#13#10 +
    'This operation canceled.', PChar(Application.Title), MB_OK + MB_ICONSTOP);
    breakloopbool := true;
    Application.Terminate;
  end;
  textsave.Free;
  strzzz.Free;
end;

procedure TMainform.COME_Make_Thumb(OutPutPath : string;
                                    PicBox_Sidesize : integer = 128;
                                    CompressionQuality : integer = 85);
var
  ResultBitmap32 : TBitmap32;
  tmpbitmap :  TBitmap;
  ResultJpeg: TJPEGImage;
  i : Integer;
  Cur_Height, Cur_Width, New_Width, New_Height : Integer;
  rotate_int, flip_v_int, flip_h_int : Integer;  
begin
  MainBitmap32 := TBitmap32.Create;
  ResultBitmap32 := TBitmap32.Create;
  tmpbitmap := TBitmap.Create;
  ResultJpeg := TJPEGImage.Create;

  MainBitmap32.StretchFilter := sfLanczos;

  for i := 0 to ListView1.Items.Count -1 do
  begin
    MainBitmap32.Clear;
    ResultBitmap32.Clear;

    MainBitmap32.LoadFromFile(ListView1.Items[i].SubItems[3]);
    
    rotate_int := StrToIntDef(ListView1.Items[i].SubItems[6], 0);
    flip_v_int := StrToIntDef(ListView1.Items[i].SubItems[7], 0);
    flip_h_int := StrToIntDef(ListView1.Items[i].SubItems[8], 0);

    COME_Deal_Rotate_Flip(MainBitmap32, rotate_int, flip_v_int, flip_h_int);

    Cur_Height := MainBitmap32.Height;
    Cur_Width := MainBitmap32.Width;

    if Cur_Width<=Cur_Height then
    begin
      New_Height := PicBox_Sidesize;
      New_Width := Round( PicBox_Sidesize / Cur_Height * Cur_Width);
    end
    else
    begin
      New_Width := PicBox_Sidesize;
      New_Height := Round( PicBox_Sidesize / Cur_Width * Cur_Height);
    end;

    COME_Modify_Resize(MainBitmap32,New_Width,New_Height,ResultBitmap32);

    tmpbitmap.Assign(ResultBitmap32);

    ResultJpeg.Assign(tmpbitmap);

    ResultJpeg.CompressionQuality := CompressionQuality;
    
    ResultJpeg.SaveToFile(OutPutPath+listview1.Items[i].SubItems[5]+'_s.jpg');

    Application.ProcessMessages;
    ProgressBar1.Position := ProgressBar1.Position + 1;
    Label_States.Caption := COME_Languages_Get_Str(Language_Strs, Language_Strs_Backup, 19) + '  ' + ListView1.Items[i].Caption + ' / ' + IntToStr(ListView1.Items.Count);
  end;

  ResultJpeg.Free;
  tmpbitmap.Free;
  ResultBitmap32.Free;
  MainBitmap32.Free;
end;

procedure TMainform.COME_Make_View_Photo(OutPutPath: string; CompressionQuality : integer = 85);
var
  ResultBitmap32 : TBitmap32;
  tmpbitmap :  TBitmap;
  ResultJpeg: TJPEGImage;
  i : Integer;
  New_Width, New_Height : Integer;
  Cur_Width, Cur_Height : Integer;
  NewFilename : string;
  rotate_int, flip_v_int, flip_h_int : Integer;
begin
  New_Width := 0;
  New_Height := 0;
  MainBitmap32 := TBitmap32.Create;
  ResultBitmap32 := TBitmap32.Create;
  tmpbitmap := TBitmap.Create;
  ResultJpeg := TJPEGImage.Create;

  MainBitmap32.StretchFilter := sfLanczos;
  for i := 0 to ListView1.Items.Count -1 do
  begin
    MainBitmap32.Clear;
    ResultBitmap32.Clear;

    case ComboBox_Photo_Size.ItemIndex of
    0: begin New_Width := 320; New_Height := 240; end;
    1: begin New_Width := 640; New_Height := 480; end;
    2: begin New_Width := 800; New_Height := 600; end;
    3: begin New_Width := 1024; New_Height := 768; end;
    end;

    MainBitmap32.LoadFromFile(ListView1.Items[i].SubItems[3]);

    rotate_int := StrToIntDef(ListView1.Items[i].SubItems[6], 0);
    flip_v_int := StrToIntDef(ListView1.Items[i].SubItems[7], 0);
    flip_h_int := StrToIntDef(ListView1.Items[i].SubItems[8], 0);

    COME_Deal_Rotate_Flip(MainBitmap32, rotate_int, flip_v_int, flip_h_int);

    Cur_Width := MainBitmap32.Width;
    Cur_Height := MainBitmap32.Height;

    if ComboBox_Photo_Size.ItemIndex = 4 then
    begin
      New_Width := Cur_Width;
      New_Height := Cur_Height;
    end
    else
    begin
      if Cur_Width = Cur_Height then New_Height := New_Width
      else
      begin
        if Cur_Width > Cur_Height then
          New_Height := Round(New_Width / Cur_Width * Cur_Height )
        else
          New_Width := Round(New_Height / Cur_Height * Cur_Width );
      end;
    end;

    COME_Modify_Resize(MainBitmap32,New_Width,New_Height,ResultBitmap32);

    tmpbitmap.Assign(ResultBitmap32);

    ResultJpeg.Assign(tmpbitmap);

    ResultJpeg.CompressionQuality := CompressionQuality;

    NewFilename := ListView1.Items[i].SubItems[5] + '.jpg';

    ResultJpeg.SaveToFile(OutPutPath+NewFilename);

    Application.ProcessMessages;

    ProgressBar1.Position := ProgressBar1.Position + 1;
    Label_States.Caption := COME_Languages_Get_Str(Language_Strs, Language_Strs_Backup, 20) + '  ' + ListView1.Items[i].Caption + ' / ' + IntToStr(ListView1.Items.Count) + ' "'+ ListView1.Items[i].SubItems[0] +'"';
  end;

  ResultJpeg.Free;
  tmpbitmap.Free;
  ResultBitmap32.Free;
  MainBitmap32.Free;
end;

procedure TMainform.Btn_Open_folderClick(Sender: TObject);
var
  tmpstr : string;
begin
  tmpstr := Edit_DestDir.Text;
  ShellExecute(0,nil,PChar(tmpstr),nil,nil,SW_SHOW);
end;

procedure TMainform.Menu_ExitClick(Sender: TObject);
begin
  Self.Close;
end;

procedure TMainform.CheckBox_BacktoHomeClick(Sender: TObject);
begin
  Save_Changed := True;
  Edit_BacktoHome.Enabled := CheckBox_BacktoHome.Checked;
end;

procedure TMainform.PageControl1Change(Sender: TObject);
begin
  Btn_Back.Enabled := True;
  Btn_Next.Enabled := True;
  case PageControl1.ActivePageIndex of
  0:
  begin
    Label_Hint.Caption := COME_Languages_Get_Str(Language_Strs, Language_Strs_Backup, 0);
    //'Step 1 of 2 : Add photos to this album.'
    Btn_Generate.Show;
    Btn_Next.Show;
    Btn_Back.Show;

    Btn_Back.Enabled := False;
    TabSheet_Generate.TabVisible := false;
    Btn_Generate.Enabled := False;
  end;
  1:
  begin
    Label_Hint.Caption := COME_Languages_Get_Str(Language_Strs, Language_Strs_Backup, 1);
    //'Step 2 of 2 : Edit your photo album.'
    Btn_Generate.Show;
    Btn_Next.Show;
    Btn_Back.Show;
    Btn_Next.Enabled := False;
    TabSheet_Generate.TabVisible := false;
    Btn_Generate.Enabled := True;
  end;
  2:
  begin
    Label_Hint.Caption := COME_Languages_Get_Str(Language_Strs, Language_Strs_Backup, 2);
    Btn_Next.Enabled := False;
    Btn_Generate.Enabled := False;    
  end;
  end;
end;

procedure TMainform.Btn_GenerateClick(Sender: TObject);
var
  i,j, x, y, z : integer;
  HTMLStr : TStringList;
  NewName : string;
  How_Many_Photos_per_page, Pics_total, num_row, num_column : Integer;
  PicBox_Sidesize : Integer;
  cur_pages: Integer;
  tmpfilename : string;

  iwebalbum_output_path, res_output_path, photo_output_path : string;
begin
  if ListView1.Items.Count = 0 then
  begin
    MessageBoxW(Handle, PWideChar(COME_Languages_Get_Str(Language_Strs, Language_Strs_Backup, 3)), 'iWebAlbum', MB_OK + MB_ICONINFORMATION);
    //'There are no photos in this album to generate. '
    Exit;
  end;

    iwebalbum_output_path := ChkFolder(Edit_DestDir.Text);

    if not DirectoryExists(iwebalbum_output_path) then
      if not ForceDirectories(iwebalbum_output_path) then
      begin
        Application.MessageBox(pchar('Could not create directory "' + iwebalbum_output_path +'"'), PChar(Application.Title),
        MB_OK + MB_ICONSTOP);
        Exit;
      end;

    res_output_path := iwebalbum_output_path +'iwebalbumfiles\';

    try
      if DirectoryExists(res_output_path) then
      begin
        StFileOperation2.SourceFiles.Text := res_output_path + '*.*';
        StFileOperation2.Execute;
      end;
    except
    end;

    if not DirectoryExists(res_output_path) then
      if not ForceDirectories(res_output_path) then
      begin
        Application.MessageBox(pchar('Could not create directory "' + res_output_path +'"'), PChar(Application.Title),
        MB_OK + MB_ICONSTOP);
        Exit;
      end;

  Btn_Generate.Hide;
  Btn_Next.Hide;
  Btn_Back.Hide;

  //===================== define [
  num_row := StrToIntDef(Edit_Row.Text, 3);
  num_column := StrToIntDef(Edit_Columns.Text, 5);

  How_Many_Photos_per_page := num_row * num_column;  
  PicBox_Sidesize := StrToIntDef(Style_Config_thumbnailsize, 120);
  Pics_total := ListView1.Items.Count;
  //===================== define ]

  FlatPanel1.Hide;
  Btn_View_Album.Enabled := False;
  Btn_Open_folder.Enabled := False;
  Label_Finished.Visible := False;

  Label_States.Caption := COME_Languages_Get_Str(Language_Strs, Language_Strs_Backup, 20);
  Label_Hint.Caption := COME_Languages_Get_Str(Language_Strs, Language_Strs_Backup, 2);
  //  'Generating ...'

  TabSheet_Generate.TabVisible := True;
  PageControl1.ActivePageIndex := 2;


  //==================================================================================
  // Make HTML

  //----get how many pages will be generated [
  if (Pics_total / How_Many_Photos_per_page) > (Pics_total div How_Many_Photos_per_page) then
    Pages := Pics_total div How_Many_Photos_per_page + 1
  else
    Pages := Pics_total div How_Many_Photos_per_page;
  //----get how many pages will be generated ]


  HTMLStr := TStringList.Create;
  HTMLStr.Clear;

      z := 0;
      for j := 0 to Pages-1 do
      begin
        HTMLStr.Add('<table border="0" cellpadding="0" cellspacing="0" class="iwebalbum_table">');

          for x := 0 to num_row -1 do
          begin
            HTMLStr.Add('<tr>');
            for y := 0 to  num_column -1 do
            begin
              tmpfilename := listview1.Items[z].SubItems[5];
                                                                                                                                                                                             //<a href="iwebalbumfiles/'+tmpfilename+'.jpg"
              HTMLStr.Add('<td><table border="0" cellspacing="0" cellpadding="0" class="iwebalbum_photobox_table"><tr><td class="iwebalbum_photobox_table_td" align="center" valign="middle"><a href="#" onclick="return GB_showImageSet(iWebAlbumPhotos, '+inttostr(z+1)+')" title="'+listview1.Items[z].SubItems[0]+'"><img src="iwebalbumfiles/'+tmpfilename+'_s.jpg" alt="'+listview1.Items[z].SubItems[0]+'" class="photobox" /></a></td></tr></table></td>');

              z := z +1;
              if z = Pics_total then Break;
            end;
            HTMLStr.Add('</tr>');
            if z = Pics_total then Break;
          end;


        HTMLStr.Add('</table>');

        if j = 0 then
          NewName := 'index.html'
        else
          NewName := 'index_'+inttostr(j+1)+'.html';

        COME_Deal_ReplaceStr(StylePath + Style_Config_indexpage_template_file, iwebalbum_output_path,  NewName, 0, j+1, HTMLStr.Text);
        HTMLStr.Clear;
      end;
      HTMLStr.Free;

  ProgressBar1.Min := 0;
  ProgressBar1.Max := ListView1.Items.Count * 2;
  ProgressBar1.Position := 0;

  StFileOperation1.SourceFiles.Clear;
  StFileOperation1.SourceFiles.Add(StylePath + 'res\*.*');
  StFileOperation1.Destination := res_output_path;
  StFileOperation1.Execute;

  COME_Make_View_Photo(res_output_path);
  COME_Make_Thumb(res_output_path, PicBox_Sidesize);
  COME_Save_photolist(res_output_path);
  COME_Project_Save_as(res_output_path+'album.iwa');

  Btn_View_Album.Enabled := True;
  Btn_Open_folder.Enabled := True;
  FlatPanel1.Show;
  Label_Finished.Visible := true;
  Label_States.Caption := '';
end;

procedure TMainform.Btn_Select_FolderClick(Sender: TObject);
var
  Info:TBrowseInfoW;
  Dir:array[0..260] of char;
  ItemId:PItemIDList;
  PathStr : string;
begin
  with Info do
  begin
    hwndOwner:=Self.Handle;
    pidlRoot:=nil;
    pszDisplayName:=nil;
    lpszTitle:= PWideChar(Btn_Select_Folder.Caption + ':');
    ulFlags:=0 or $0040;
    lpfn:=nil;
    lParam:=0;
    iImage:=0;
  end;
  ItemId:=SHBrowseForFolderW(Info);
  SHGetPathFromIDList(ItemId,@Dir);
  PathStr:=string(Dir);

  if PathStr <> '' then Edit_DestDir.Text := ChkFolder(PathStr) + 'mywebalbum';
end;

procedure TMainform.Btn_Add_ImagesClick(Sender: TObject);
var
i : integer;
begin
  if OpenPictureDialog1.Execute then
  begin
    for i := 0 to (OpenPictureDialog1.Files.Count -1) do
      COME_Add_Images(OpenPictureDialog1.Files[i]);

    COME_Get_Listview1_ID;
  end;
end;

procedure TMainform.Btn_Remove_ImagesClick(Sender: TObject);
var
  tmpint : integer;
begin
  tmpint := ListView1.ItemIndex;
  ListView1.DeleteSelected;
  Label1.Hint := IntToStr(ListView1.Items.Count);
  Label1.Caption := Language_HTML_Strs[2]+ ': ' + Label1.Hint;

  Save_Changed := true;
  COME_Get_Listview1_ID;
  
  ListView1.SetFocus;
  if tmpint+1 < ListView1.Items.Count then
  begin
    ListView1.ItemIndex := tmpint;
    ListView1.Selected.MakeVisible(True);
    COME_Deal_PreviewThumb(ListView1.Selected.SubItems[3]);
  end
  else
    Image321.Bitmap.Delete;
end;

procedure TMainform.Btn_Remove_AllClick(Sender: TObject);
begin
  ListView1.Clear;
  
  Label1.Hint := IntToStr(ListView1.Items.Count);
  Label1.Caption := Language_HTML_Strs[2]+ ': ' + Label1.Hint;

  Save_Changed := true;
  COME_Get_Listview1_ID;

  Image321.Bitmap.Delete;
end;

procedure TMainform.Btn_DownClick(Sender: TObject);
begin
  COME_Set_Listview1_Index( ListView1.Selected.Index + 1 );
end;

procedure TMainform.Btn_View_AlbumClick(Sender: TObject);
begin
  ShellExecute(0,nil,PChar(ChkFolder(Edit_DestDir.Text)+'index.html'),nil,nil,SW_SHOW);
end;

procedure TMainform.Btn_Modify_SelectedClick(Sender: TObject);
begin
  Save_Changed := true;
  with Tc_modify_form.Create(Self) do
  begin
    ShowModal;
    Free;
  end;
end;

procedure TMainform.Menu_AboutClick(Sender: TObject);
begin
  with Tc_AboutForm.Create(Self) do
  begin
    Image_about.Picture := Image1.Picture;
    Label_Version.Caption := iWebAlbum_Version;
    Label_Language.Caption := G_Language;
    Label_Trans.Caption := COME_Languages_Get_Str(Language_Strs, Language_Strs_Backup, 21)+ ' ' + G_Language_Translator;
    ShowModal;
    Free;
  end;
end;

procedure TMainform.COME_WEBINFO(INFO: integer);
const
  website = '0F000000000000004F6CE38F8AAAB631D489B3DA37AB11F8';
  email = '18000000000000004B500EEB2E8A52D9D595A1922FCB3A93C8CB250C545736C283AFA9F8611BC6BD';
begin
  case INFO of
    0 : // website, URL=http://www.eunq.com
    ShellExecute(0,nil,PChar(Trim(DecryptString(website, AES_Key, kb256))),nil,nil,SW_SHOW);

    1 : // email, URL=mailto:eunqcom@gmail.com
    ShellExecute(0,nil,PChar(Trim(DecryptString(email, AES_Key, kb256))),nil,nil,SW_SHOW);

    2 : // checknewversion, URL=http://www.eunq.com/updates.html
    ShellExecute(0,nil,PChar(Trim(DecryptString(website, AES_Key, kb256))+'/updates/?p=iwa&v='+iWebAlbum_Version),nil,nil,SW_SHOW);

    3 : // help
    ShellExecute(0,nil,PChar(Trim(DecryptString(website, AES_Key, kb256))+'/help.html'),nil,nil,SW_SHOW);

    4 : // language
    ShellExecute(0,nil,PChar(Trim(DecryptString(website, AES_Key, kb256))+'/language.html'),nil,nil,SW_SHOW);

    5 : // upload
    ShellExecute(0,nil,PChar(Trim(DecryptString(website, AES_Key, kb256))+'/help-how-to-share.html'),nil,nil,SW_SHOW);

    6 : // sample web album
    ShellExecute(0,nil,PChar(Trim(DecryptString(website, AES_Key, kb256))+'/sample-album-default-skin-dark/'),nil,nil,SW_SHOW);
  end;

end;

procedure TMainform.Menu_WebsiteofPhototoClick(Sender: TObject);
begin
  COME_WEBINFO(0); // website
end;

procedure TMainform.Menu_CheckforanewversionClick(Sender: TObject);
begin
  COME_WEBINFO(2); // checknewverison
end;

procedure TMainform.Menu_HelpdocClick(Sender: TObject);
begin
  COME_WEBINFO(3); // help
end;

procedure TMainform.Btn_UpClick(Sender: TObject);
begin
  COME_Set_Listview1_Index( ListView1.Selected.Index - 1 );
end;

procedure TMainform.COME_Project_New;
begin
  Saved_Filename := '';
  ListView1.Clear;
  Edit_Album_Title.Text := 'My Web Photo Album';
  Edit_Album_Comments.Text := 'Album Comments';
  Edit_DestDir.Text := ChkFolder(GetMyDocumentDirectory) + 'mywebalbum';
  ComboBox_Style.ItemIndex := 0;
  ComboBox_Photo_Size.ItemIndex := 1;
  CheckBox_BacktoHome.Checked := False;
  Edit_BacktoHome.Text := 'http://';
  PageControl1.ActivePageIndex := 0;
  PageControl1.OnChange(self);
  Image321.Bitmap.Delete;
  Save_Changed := False;  
end;

procedure TMainform.COME_Project_Save;
begin
  COME_Project_Save_as(Saved_Filename);
end;

procedure TMainform.COME_Project_Save_as(filename : string = '');
var
  i : Integer;
  savefile : string;
  XMLBox : TXMLDocument;
  root, root2 : IXMLNode;
begin
  if filename = '' then
  begin
    if not SaveDialog1.Execute then exit;
    savefile := SaveDialog1.FileName;
  end
  else
  begin
    savefile := filename;
  end;

  XMLBox := TXMLDocument.Create(Self);
  XMLBox.Options := [doNodeAutoCreate, doAttrNull, doAutoPrefix, doNamespaceDecl, doNodeAutoIndent];
  XMLBox.Active := true;
  XMLBox.Encoding := 'UTF-8';
  root := XMLBox.CreateNode('album');
  XMLBox.DocumentElement := root;

  root2 := root.AddChild('info');
  root2.AddChild('title').Text := Edit_Album_Title.Text;
  root2.AddChild('comments').Text := Edit_Album_Comments.Text;
  root2.AddChild('output').Text := Edit_DestDir.Text;
  root2.AddChild('photosize').Text := IntToStr(ComboBox_Photo_Size.ItemIndex);
  root2.AddChild('url').Text := Edit_BacktoHome.Text;

  for i := 0 to ListView1.Items.Count-1 do
  begin
    root2 := root.AddChild('photo');
    root2.AddChild('title').Text := ListView1.Items[i].SubItems[0];
    root2.AddChild('comments').Text := ListView1.Items[i].SubItems[1];
    root2.AddChild('filename').Text := ListView1.Items[i].SubItems[3];
    root2.AddChild('rotateinfo').Text := ListView1.Items[i].SubItems[6];
    root2.AddChild('flip_v_info').Text := ListView1.Items[i].SubItems[7];
    root2.AddChild('flip_h_info').Text := ListView1.Items[i].SubItems[8];
  end;

  XMLBox.SaveToFile(savefile);
  XMLBox.Active := False;
  XMLBox.Free;

  Save_Changed := False;
end;

procedure TMainform.COME_Project_Load(loadfilename : string = '');
var
  XMLfile : string;
  XMLBox : TXMLDocument;
  Root : IXMLNode;
  Child: IXMLNode;
  i : Integer;
  title, comments, filename, rotateinfo, flip_v_info, flip_h_info : WideString;
  tmp : TTntListItem;
  id : TGUID;
begin
  if loadfilename = '' then
  begin
    if not OpenDialog1.Execute then exit;
    XMLfile := OpenDialog1.FileName;
  end
  else
  begin
    XMLfile := loadfilename;
  end;

  COME_Project_New;
  Save_Changed := False;
  XMLBox := TXMLDocument.Create(Self);
  XMLBox.LoadFromFile(XMLfile);

  Root := XMLBox.DocumentElement;
  Child := Root.ChildNodes.First;

  Edit_Album_Title.Text := Child.ChildNodes.Nodes['title'].Text;
  Edit_Album_Comments.Text := Child.ChildNodes.Nodes['comments'].Text;
  Edit_DestDir.Text := Child.ChildNodes.Nodes['output'].Text;
  ComboBox_Photo_Size.ItemIndex := StrToIntDef(Child.ChildNodes.Nodes['photosize'].Text, 1);

  Edit_BacktoHome.Text := Child.ChildNodes.Nodes['url'].Text;
  if Edit_BacktoHome.Text <> 'http://' then
    CheckBox_BacktoHome.Checked := true
  else
    CheckBox_BacktoHome.Checked := False;

  child := child.NextSibling;
  for i := 1 to  Root.ChildNodes.Count - 1 do
  begin

    title := Child.ChildNodes.Nodes['title'].Text;
    comments := Child.ChildNodes.Nodes['comments'].Text;
    filename := Child.ChildNodes.Nodes['filename'].Text;
    rotateinfo := Child.ChildNodes.Nodes['rotateinfo'].Text;
    flip_v_info := Child.ChildNodes.Nodes['flip_v_info'].Text;
    flip_h_info := Child.ChildNodes.Nodes['flip_h_info'].Text;

  try
    if FileExists(filename) then
    begin
      tmp := ListView1.Items.Add;
      tmp.Caption := '';
      tmp.ImageIndex := WhichImageFile(filename);
      tmp.SubItems.Add(title);
      tmp.SubItems.Add(comments);
      tmp.SubItems.Add(MyGetFileSize(filename));
      tmp.SubItems.Add(filename);
      tmp.SubItems.Add('');
      if CoCreateGuid (Id) = s_OK then
        tmp.SubItems.Add(ChangeGuid(GUIDToString(id)))
      else
        ShowMessage('GUID Error, please contact the author, thanks.');
      end;
      tmp.SubItems.Add(rotateinfo);
      tmp.SubItems.Add(flip_v_info);
      tmp.SubItems.Add(flip_h_info);
  except
  end;
    child := child.NextSibling;

    end;
  Saved_Filename := XMLfile;
  Save_Changed := False;
  COME_Get_Listview1_ID;

  XMLBox.Free;

  Label1.Hint := IntToStr(ListView1.Items.Count);
  Label1.Caption := Language_HTML_Strs[2]+ ': ' + Label1.Hint;
end;

procedure TMainform.Menu_NewprojectClick(Sender: TObject);
begin
  COME_Project_New;
end;

procedure TMainform.Menu_SaveprojectClick(Sender: TObject);
begin
  COME_Project_Save;
end;

procedure TMainform.Menu_LoadprojectClick(Sender: TObject);
begin
  COME_Project_Load;
end;

procedure TMainform.Menu_SaveAlbumasClick(Sender: TObject);
begin
  COME_Project_Save_as;
end;

procedure TMainform.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  {
  if Save_Changed then
    if MessageBoxW(Handle, PWideChar(COME_Languages_Get_Str(Language_Strs, Language_Strs_Backup, 6)), 'iWebAlbum',
    MB_YESNO + MB_ICONINFORMATION) = IDNO
    then
      CanClose := False
    else
      CanClose := True;
  }
end;

procedure TMainform.Edit_Album_CommentsChange(Sender: TObject);
begin
  Save_Changed := True;
end;

procedure TMainform.Edit_Album_TitleChange(Sender: TObject);
begin
  Save_Changed := True;
end;

procedure TMainform.ComboBox_Photo_SizeChange(Sender: TObject);
begin
  Save_Changed := True;
end;

procedure TMainform.ComboBox_StyleChange(Sender: TObject);
var
  Root_Nodes : IXMLNode;
  i : Integer;
begin
  SkinPath := APP_PATH + 'Templetlab\' + ComboBox_Style.Text + '\';

  XMLDocument1.LoadFromFile(SkinPath + 'config.xml');

  Root_Nodes := XMLDocument1.DocumentElement;

  ComboBox_Style2.Clear;
  for i := 0 to Root_Nodes.ChildNodes.Nodes['skin'].ChildNodes.Count - 1 do
    ComboBox_Style2.Items.Add(Root_Nodes.ChildNodes.Nodes['skin'].ChildNodes.Nodes[i].ChildNodes.Nodes['name'].Text);
  ComboBox_Style2.ItemIndex := 0;
  ComboBox_Style2.OnChange(self);
end;

procedure TMainform.Edit_DestDirChange(Sender: TObject);
begin
  Save_Changed := True;
end;

procedure TMainform.Edit_BacktoHomeChange(Sender: TObject);
begin
  Save_Changed := True;
end;

procedure TMainform.COME_Language(Language_File: string);
var
  XMLBox : TXMLDocument;
  Root, Cur_Nodes : IXMLNode;
  i,j : Integer;
  tmp_WidStr : WideString;
begin
  XMLBox := TXMLDocument.Create(Self);
  XMLBox.LoadFromFile(Language_File);
  XMLBox.Active := True;
  G_Language_Filename := ExtractFileName(Language_File);
  Root := XMLBox.DocumentElement;

  Cur_Nodes := Root.ChildNodes.Nodes['info'];
  G_Language := Cur_Nodes.ChildNodes.Nodes['language'].Text;
  G_Language_Translator := Cur_Nodes.ChildNodes.Nodes['translator'].Text;

  for i := 0 to MainMenu1.Items[1].Count -1 do
    MainMenu1.Items[1].Items[i].Default := MainMenu1.Items[1].Items[i].Hint = G_Language_Filename;

  Cur_Nodes := Root.ChildNodes.Nodes['Components'];
  for i := 0 to Cur_Nodes.ChildNodes.Count - 1 do
  begin
   if FindComponent(Cur_Nodes.ChildNodes.Nodes[i].LocalName) <> nil then
     if FindComponent(Cur_Nodes.ChildNodes.Nodes[i].LocalName).Tag = 8 then
        for j := 0 to Cur_Nodes.ChildNodes.Nodes[i].ChildNodes.Count -1 do
        begin
          try
            SetPropValue(FindComponent(Cur_Nodes.ChildNodes.Nodes[i].LocalName), Cur_Nodes.ChildNodes.Nodes[i].ChildNodes.Nodes[j].LocalName, Cur_Nodes.ChildNodes.Nodes[i].ChildNodes.Nodes[j].Text);
          except
          end;
        end;
  end;

  Menu_Addimages.Caption := Btn_Add_Images.Caption;
  Menu_Addfolder.Caption := Btn_Add_Folder.Caption;
  Menu_RemoveImages.Caption := Btn_Remove_Images.Caption;
  Menu_Removeall.Caption := Btn_Remove_All.Caption;

  Cur_Nodes := Root.ChildNodes.Nodes['Strings'];
  Language_Strs.Clear;
  for i := 0 to Cur_Nodes.ChildNodes.Count - 1 do
  begin
    Language_Strs.Add(Cur_Nodes.ChildNodes.Nodes[i].Text);
  end;

  Cur_Nodes := Root.ChildNodes.Nodes['HTMLStrings'];
  Language_HTML_Strs.Clear;
  for i := 0 to Cur_Nodes.ChildNodes.Count - 1 do
  begin
    Language_HTML_Strs.Add(Cur_Nodes.ChildNodes.Nodes[i].Text);
  end;

  XMLBox.Free;

  try
  ListView1.Columns[0].Caption := COME_Languages_Get_Str(Language_Strs, Language_Strs_Backup, 7);
  ListView1.Columns[1].Caption := COME_Languages_Get_Str(Language_Strs, Language_Strs_Backup, 8);
  ListView1.Columns[2].Caption := COME_Languages_Get_Str(Language_Strs, Language_Strs_Backup, 9);
  ListView1.Columns[3].Caption := COME_Languages_Get_Str(Language_Strs, Language_Strs_Backup, 10);
  ListView1.Columns[4].Caption := COME_Languages_Get_Str(Language_Strs, Language_Strs_Backup, 11);
  ListView1.Columns[5].Caption := COME_Languages_Get_Str(Language_Strs, Language_Strs_Backup, 22);  

  ComboBox_Photo_Size.Items[0] := COME_Languages_Get_Str(Language_Strs, Language_Strs_Backup, 12);
  ComboBox_Photo_Size.Items[1] := COME_Languages_Get_Str(Language_Strs, Language_Strs_Backup, 13);
  ComboBox_Photo_Size.Items[2] := COME_Languages_Get_Str(Language_Strs, Language_Strs_Backup, 14);
  ComboBox_Photo_Size.Items[3] := COME_Languages_Get_Str(Language_Strs, Language_Strs_Backup, 15);
  ComboBox_Photo_Size.Items[4] := COME_Languages_Get_Str(Language_Strs, Language_Strs_Backup, 16);
  ComboBox_Photo_Size.ItemIndex := 1;

  if (G_Language_Filename = 'language_en.xml') then
    SetPropValue(MainMenu1.Items[1], 'Caption', '&Language')
  else
    SetPropValue(MainMenu1.Items[1], 'Caption', COME_Languages_Get_Str(Language_Strs, Language_Strs_Backup, 18) + ' [&Language]')
  except end;

  Label1.Caption := Language_HTML_Strs[2]+ ': ' + Label1.Hint;

  PageControl1Change(nil);

  COME_Write_Config_XML(APP_CONFIG_FILENAME, 'language', G_Language_Filename);
end;

procedure TMainform.COME_Language_Write_XML(Language_File: string);
var
  i : Integer;
  XMLBox : TXMLDocument;
  root, root2, root3 : IXMLNode;
begin
  G_for_Language := True;
  XMLBox := TXMLDocument.Create(nil);
  XMLBox.Options := [doNodeAutoCreate, doAttrNull, doAutoPrefix, doNamespaceDecl, doNodeAutoIndent];
  XMLBox.Active := true;
  XMLBox.Encoding := 'UTF-8';
  root := XMLBox.CreateNode('language');
  XMLBox.DocumentElement := root;

  root2 := root.AddChild('info');
  root2.AddChild('language').Text := G_Language;
  root2.AddChild('translator').Text := G_Language_Translator;
  root2.AddChild('verion').Text := iWebAlbum_Version;

  root2 := root.AddChild('Components');
  for i := 0 to ComponentCount - 1 do
  begin
    if (Components[i].Tag = 8) and IsAPropExist(Components[i], 'Caption') then
    begin
      root3 := root2.AddChild(Components[i].Name);
      root3.AddChild('Caption').Text := GetPropValue(Components[i],'Caption');
    end;
  end;

  root2 := root.AddChild('ModifyForm');
  with Tc_modify_form.Create(Self) do
  begin
    Show;
    for i := 0 to ComponentCount - 1 do
      if (Components[i].Tag = 8) and IsAPropExist(Components[i], 'Caption') then
      begin
        root3 := root2.AddChild(Components[i].Name);
        root3.AddChild('Caption').Text := GetPropValue(Components[i],'Caption');
      end;
    Close;
    Free;
  end;
  root2 := root.AddChild('About');
  with Tc_AboutForm.Create(Self) do
  begin
    Show;
    for i := 0 to ComponentCount - 1 do
      if (Components[i].Tag = 8) and IsAPropExist(Components[i], 'Caption') then
      begin
        root3 := root2.AddChild(Components[i].Name);
        root3.AddChild('Caption').Text := GetPropValue(Components[i],'Caption');
      end;
    Close;
    Free;
  end;

  root2 := root.AddChild('Strings');
  for i := 0 to Language_Strs.Count - 1 do
    root2.AddChild('s'+IntToStr(i)).Text := Language_Strs.Strings[i];
  if Language_Strs_Backup.Count > Language_Strs.Count then
    for i := (Language_Strs.Count) to (Language_Strs_Backup.Count - 1) do
      root2.AddChild('s'+IntToStr(i)).Text := Language_Strs_Backup.Strings[i];

  root2 := root.AddChild('HTMLStrings');
  for i := 0 to Language_HTML_Strs.Count - 1 do
    root2.AddChild('s'+IntToStr(i)).Text := Language_HTML_Strs.Strings[i];
  if Language_HTML_Strs_Backup.Count > Language_HTML_Strs.Count then
    for i := (Language_HTML_Strs.Count) to (Language_HTML_Strs_Backup.Count - 1) do
      root2.AddChild('s'+IntToStr(i)).Text := Language_HTML_Strs_Backup.Strings[i];

  XMLBox.SaveToFile(Language_File);
  XMLBox.Active := False;
  XMLBox.Free;

  G_for_Language := False;
end;

procedure TMainform.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Language_Strs.Free;
  Language_Strs_Backup.Free;
end;

procedure TMainform.COME_Languages_To_Menu(xml_filename: string);
var
  l_item : TTntMenuItem;
  Cur_Nodes : IXMLNode;
  W_language : WideString;
begin
  W_language := '';
  XMLDocument1.LoadFromFile(xml_filename);
  Cur_Nodes := XMLDocument1.DocumentElement.ChildNodes.Nodes['info'];
  W_language := Cur_Nodes.ChildNodes.Nodes['language'].Text;
  if W_language <> '' then
  begin
    l_item := TTntMenuItem.Create(Self);
    l_item.Caption := W_language;
    l_item.Default := W_language = G_Language;
    l_item.Hint := ExtractFileName(xml_filename);
    l_item.OnClick := MenuItem_Click;
    MainMenu1.Items[1].Add(l_item);
  end;
end;

procedure TMainform.JvSearchFiles2FindFile(Sender: TObject;
  const AName: String);
begin
  COME_Languages_To_Menu(AName);
end;

procedure TMainform.MenuItem_Click(Sender: TObject);
begin
  COME_Language(APP_LANGUAGE_PATH + TTntMenuItem(Sender).Hint);
end;

procedure TMainform.FormShow(Sender: TObject);
{var
  Reg:TRegistry;}
begin
   {
  //   .iwa ļ <
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CLASSES_ROOT;
    Reg.OpenKey('iWebAlbumProject\Shell\Open\Command', false);
    if UpperCase(Reg.ReadString('')) <> UpperCase('"'+Application.ExeName + '" "%1"') then
      SetFileAssociate('.IWA','iWebAlbumProject', 'iWebAlbum Project File',Application.ExeName);
  finally
    reg.Free;
  end;
  //   .iwa ļ >
  }

  Language_HTML_Strs := TTntStringList.Create;
  Language_HTML_Strs.Add('Comments'); //0
  Language_HTML_Strs.Add('Information'); //1
  Language_HTML_Strs.Add('Total'); //2
  Language_HTML_Strs.Add('Album'); //3
  Language_HTML_Strs.Add('Previous'); //4
  Language_HTML_Strs.Add('Back to index page'); //5
  Language_HTML_Strs.Add('Next'); //6
  Language_HTML_Strs.Add('Page'); //7
  Language_HTML_Strs.Add('Generated by'); //8
  Language_HTML_Strs.Add('Back to home page'); //9
  Language_HTML_Strs.Add('Start slideshow'); //10
  Language_HTML_Strs.Add('Stop slideshow'); //11

  Language_HTML_Strs_Backup := TTntStringList.Create;
  Language_HTML_Strs_Backup.Text := Language_HTML_Strs.Text;

  Language_Strs := TTntStringList.Create;
  Language_Strs.Add('Step 1 of 2 : Add photos to this album.'); //0
  Language_Strs.Add('Step 2 of 2 : Edit your photo album.'); //1
  Language_Strs.Add('Generating ...'); //2
  Language_Strs.Add('There are no photos in this album to generate. '); //3
  Language_Strs.Add('The current project has not been saved. Are you sure you want to create a new project?'); //4
  Language_Strs.Add('The current project has not been saved. Are you sure you want to open a new project?'); //5
  Language_Strs.Add('The current project has not been saved. Are you sure you want to close iWebAlbum?'); //6
  Language_Strs.Add('ID'); //7
  Language_Strs.Add('Title'); //8
  Language_Strs.Add('Comments'); //9
  Language_Strs.Add('Size'); //10
  Language_Strs.Add('Filename'); //11
  Language_Strs.Add('Small (320 x 240)'); //12
  Language_Strs.Add('Medium (640 x 480)'); //13
  Language_Strs.Add('Large (800 x 600)'); //14
  Language_Strs.Add('Extra Large (1024 x 768)'); //15
  Language_Strs.Add('Original Size'); //16
  Language_Strs.Add('Select a folder which contains image files:'); //17
  Language_Strs.Add('Language'); //18
  Language_Strs.Add('Please wait ...  Processing thumbnails:'); //19
  Language_Strs.Add('Please wait ...  Processing photo:'); //20
  Language_Strs.Add('Translation by'); //21
  Language_Strs.Add('Date Picture Taken'); //22          

  Language_Strs_Backup := TTntStringList.Create;
  Language_Strs_Backup.Text := Language_Strs.Text;

  TabSheet_Generate.TabVisible := False;
  PageControl1.ActivePageIndex := 0;
  PageControl1Change(nil);
  Edit_DestDir.Text := ChkFolder(GetMyDocumentDirectory) + 'mywebalbum';
  APP_PATH := ExtractFilePath(ParamStr(0));
  APP_LANGUAGE_PATH := APP_PATH + 'language\';
  APP_CONFIG_FILENAME := APP_PATH + 'config.xml';
  APP_PHOTO_PATH := 'iwebalbumphotos\';
  APP_RES_PATH := 'res\';
  Save_Changed := False;

  COME_Deal_ParaStr;

  G_Language_Filename := COME_Read_Config_XML(APP_CONFIG_FILENAME, 'language');
  if (G_Language_Filename = '') or (G_Language_Filename = 'language_en.xml') then
  begin
    G_Language_Filename := 'language_en.xml';
    G_Language_Translator := 'EunQ';
    G_Language := 'English (English)';
  end
  else
  begin
    try
    COME_Language(APP_LANGUAGE_PATH + G_Language_Filename);
    except
      G_Language_Filename := 'language_en.xml';
      G_Language_Translator := 'EunQ';
      G_Language := 'English';
    end;
  end;

  // languageĿ¼, ҵеķļ <
  JvSearchFiles2.RootDirectory := APP_LANGUAGE_PATH;
  JvSearchFiles2.Search;
  // languageĿ¼, ҵеķļ >

  // skinĿ¼, ѽComboBox_Style. <
  EasyFileSearch1.RootPath := APP_PATH + 'Templetlab\';
  EasyFileSearch1.SearchOptions := [okLookForDirectory];
  EasyFileSearch1.Search;

  ComboBox_Style.ItemIndex := ComboBox_Style.Items.IndexOf('Default-skin');

  SkinPath := APP_PATH + 'Templetlab\' + ComboBox_Style.Text + '\';
  ComboBox_Style.OnChange(Self); //뵱ǰskinĿ¼µconfig.xml
                                //ComboBox_Style2.
  ComboBox_Style2.OnChange(Self);
  // skinĿ¼, ѽComboBox_Style. >


  Self.Caption := 'iWebAlbum ' + iWebAlbum_Version;
end;

procedure TMainform.TntButton1Click(Sender: TObject);
var
  SaveDig : TTNTSaveDialog;
begin
  SaveDig := TTntSaveDialog.Create(Self);
  SaveDig.Options := [ofOverwritePrompt,ofEnableSizing];
  SaveDig.InitialDir := APP_LANGUAGE_PATH;
  SaveDig.FileName := 'language_xx';
  SaveDig.DefaultExt := 'xml';
  SaveDig.Filter := 'XML (*.xml) |*.xml';
  if SaveDig.Execute then
    COME_Language_Write_XML(SaveDig.FileName);
end;

function TMainform.COME_Read_Config_XML(XML_File : string; Name : WideString): WideString;
begin
  try
  XMLDocument1.LoadFromFile(XML_File);
  Result := XMLDocument1.DocumentElement.ChildNodes[Name].Text;
  except
    Result := ''
  end;
end;

procedure TMainform.COME_Write_Config_XML(XML_File: string; Name : WideString; Value : WideString);
var
  XML_Root : IXMLNode;
begin
  XMLDocument1.Active := True;
  XMLDocument1.Encoding := 'UTF-8';
  XML_Root := XMLDocument1.CreateNode('config');
  XMLDocument1.DocumentElement := XML_Root;

  XML_Root.AddChild(Name).Text := Value;

  XMLDocument1.SaveToFile(XML_File);
  XMLDocument1.Active := False;
end;

procedure TMainform.Menu_AddimagesClick(Sender: TObject);
begin
  Btn_Add_Images.Click;
end;

procedure TMainform.Menu_AddfolderClick(Sender: TObject);
begin
  Btn_Add_Folder.Click;
end;

procedure TMainform.Menu_RemoveImagesClick(Sender: TObject);
begin
  Btn_Remove_Images.Click;
end;

procedure TMainform.Menu_RemoveallClick(Sender: TObject);
begin
  Btn_Remove_All.Click;
end;

function TMainform.COME_Languages_Get_Str(StrList, StrList_Back: TTntStringList;
                                index: Integer; Check : Boolean = False): WideString;
var
  TmpWStr : WideString;
begin
  if index <= StrList.Count -1 then
    TmpWStr := StrList[index]
  else
    TmpWStr := StrList_Back[index];

  if Check and not(G_Check) then
    if (Pos('<',TmpWStr)>0) or (pos('>', TmpWStr)>0) then
    begin
      TmpWStr := '';
      MessageBox(Handle,
        'Do not use "<" or ">" in XML, this text string will be null.',
        'Error', MB_OK + MB_ICONSTOP);
      G_Check := true;
    end;

  Result := TmpWStr;
end;

procedure TMainform.Menu_Get_Update_LanguageClick(Sender: TObject);
begin
  COME_WEBINFO(0);
end;

procedure TMainform.Label_Howto_uploadClick(Sender: TObject);
begin
  Mainform.COME_WEBINFO(5); // how-to-upload;
end;

procedure TMainform.EasyFileSearch1FileFound(FileFound: TFileInformations);
begin
  if FileExists(FileFound.Path + FileFound.name + '\config.xml') then
  ComboBox_Style.Items.Add(FileFound.Name);
end;

procedure TMainform.COME_Read_Skin_XML(XML_File: string);
var
  Current_Nodes : IXMLNode;
  i : Integer;
begin
  i := ComboBox_Style2.ItemIndex;

  XMLDocument1.LoadFromFile(XML_File);
  //=================================================================
  Current_Nodes := XMLDocument1.DocumentElement.ChildNodes.Nodes['skin'].ChildNodes.Nodes[i];

  Style_Config_preview                    := lowercase(Current_Nodes.ChildNodes.Nodes['preview'].Text);
  Style_Config_outputtype                 := lowercase(Current_Nodes.ChildNodes.Nodes['output_type'].Text);
  Style_Config_thumbnailsize              := lowercase(Current_Nodes.ChildNodes.Nodes['thumbnails_size'].Text);
  Style_Config_folder                     := lowercase(Current_Nodes.ChildNodes.Nodes['folder'].Text);
  Style_Config_default_columns            := lowercase(Current_Nodes.ChildNodes.Nodes['default_columns'].Text);
  Style_Config_default_columns_enabled    := lowercase(Current_Nodes.ChildNodes.Nodes['default_columns_enabled'].Text);
  Style_Config_default_rows               := lowercase(Current_Nodes.ChildNodes.Nodes['default_rows'].Text);
  Style_Config_default_rows_enabled       := lowercase(Current_Nodes.ChildNodes.Nodes['default_columns_rows_enabled'].Text);
  Style_Config_viewpage_bool              := lowercase(Current_Nodes.ChildNodes.Nodes['viewpage_bool'].Text);
  Style_Config_indexpage_template_file    := lowercase(Current_Nodes.ChildNodes.Nodes['indexpage_template_file'].Text);
  Style_Config_viewpage_template_file     := lowercase(Current_Nodes.ChildNodes.Nodes['viewpage_template_file'].Text);
  Style_Config_thumbnails_per_page        := lowercase(Current_Nodes.ChildNodes.Nodes['preview'].Text);

  StylePath := SkinPath + Style_Config_folder + '\';
  
  Image_preview.Picture.LoadFromFile(StylePath + Style_Config_preview);

  Edit_Columns.Text := Style_Config_default_columns;
  Edit_Row.Text := Style_Config_default_rows;

  Edit_Columns.Enabled := not(Style_Config_default_columns_enabled = 'false');
  Edit_Row.Enabled := not(Style_Config_default_rows_enabled = 'false');
end;

procedure TMainform.ComboBox_Style2Change(Sender: TObject);
begin
  COME_Read_Skin_XML(SkinPath + 'config.xml');
end;

procedure TMainform.COME_Deal_Rotate_Flip(Image32: TBitmap32; rotate_int, flip_v_int, flip_h_int : Integer);
begin
  if rotate_int <> 0 then
  begin
    case (rotate_int mod 360) of
    90 :Image32.Rotate90();
    180:Image32.Rotate180();
    270:Image32.Rotate270();
    end;
  end;

  if flip_h_int <> 0 then
  begin
    case (flip_h_int mod 2) of
    1: Image32.FlipHorz();
    end;
  end;

  if flip_v_int <> 0 then
  begin
    case (flip_v_int mod 2) of
    1: Image32.FlipVert();
    end;
  end;
end;

procedure TMainform.COME_Save_photolist(outputpath: string);
var
  i : Integer;
  str1 : WideString;
  mem : TStream;
  caption_str, comment_str : WideString;
begin
  str1 := 'var iWebAlbumPhotos = [';
  for i := 0 to ListView1.Items.Count - 1 do
  begin
    caption_str := listview1.Items[i].SubItems[0];
    comment_str := listview1.Items[i].SubItems[1];

   while Pos('"',caption_str) > 0 do
   begin
    Insert('&quot;', caption_str, Pos('"',caption_str));
    Delete(caption_str,Pos('"',caption_str),1);
   end;

   while Pos('"',comment_str) > 0 do
   begin
    Insert('&quot;', comment_str, Pos('"',comment_str));
    Delete(comment_str,Pos('"',comment_str),1);
   end;


    if i <> ListView1.Items.Count -1 then
      str1 := Str1 + '{"caption": "'+caption_str+'", "url": "'+listview1.Items[i].SubItems[5]+'.jpg", "comment": "'+ comment_str + '"},'
    else
      str1 := Str1 + '{"caption": "'+caption_str+'", "url": "'+listview1.Items[i].SubItems[5]+'.jpg", "comment": "'+ comment_str +'"}];';

    mem := TMemoryStream.Create;
    UnicodeToUTF8Stream(str1, mem);
    TMemoryStream(mem).SaveToFile( outputpath + 'iwebalbumpics.js');
    mem.Size := 0;
    mem.Free;
end;
end;

procedure TMainform.Label3Click(Sender: TObject);
begin
  COME_WEBINFO(6);
end;

procedure TMainform.Label3MouseEnter(Sender: TObject);
begin
  TLabel(Sender).Font.Style := [fsUnderline];
end;

procedure TMainform.Label3MouseLeave(Sender: TObject);
begin
  TLabel(Sender).Font.Style := [];
end;

end.
